local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local BorderSize, Padding = Widgets.BorderSize, Widgets.Padding;

local InfoWindow 
local InfoDisplay = {}
_ARTG.InfoDisplay = InfoDisplay

local IconSize = 20 - 2*Padding

_ARTG.SV.RegisterSVCallback(function(varName,varValue)
	if varName == "ALL" or varName == "G_Enable" or varName == "ID_Enable" or VarName == "CurrentNote" or varName == "G_LoadConditions" then 
		_ARTG.InfoDisplay:Load()
	end 
		
	if varName == "ALL" or varName == "ID_Backdrop" or varName == "ID_Backdropr" or varName == "ID_Backdropg" or 
	varName == "ID_Backdropb" or varName == "ID_Backdropa" or varName == "ID_MatchBackdrop" or 
	varName == "ID_Anchor" or varName == "ID_AnchorPoint" or 
	(_ARTG.SV.GetVariable("ID_MatchBackdrop") and (
		(_ARTG.SV.GetVariable("ID_Anchor") == "NOTEDISPLAY" and 
			(varName == "ND_Backdrop" or varName == "ND_Backdropr" or varName == "ND_Backdropg" or varName == "ND_Backdropb" or varName == "ND_Backdropa")) 
	)) then  
		_ARTG.InfoDisplay:UpdateColor()
	end 

	if varName == "ALL" or varName == "ID_Scale" or varName == "ID_RowHeight" or varName == "ID_Width" or varName == "ID_MatchWidth" or 
	varName == "ID_Anchor" or varName == "ID_AnchorPoint" or varName == "ID_PosX" or varName == "ID_PosY" or varName == "ID_Locked" or 
		(_ARTG.SV.GetVariable("ID_Anchor")== "NOTEDISPLAY" and 
			(varName == "ND_Width" or varName == "ND_Height" or varName == "ND_PosX" or varName == "ND_PosY" or varName == "ND_Scale")) 
			
	then 
		_ARTG.InfoDisplay:UpdateDimensions()
	end 
end,"ALL","G_Enable","ID_Enable",
	"G_LoadConditions","CurrentNote",
	"ID_Backdrop","ID_Backdropr","ID_Backdropg","ID_Backdropb","ID_Backdropa","ID_MatchBackdrop",
	"ID_Anchor","ID_AnchorPoint",
	"ND_Backdrop","ND_Backdropr","ND_Backdropg","ND_Backdropb","ND_Backdropa",
	"ID_Scale","ID_RowHeight","ID_Width","ID_MatchWidth","ID_PosX","ID_PosY","ID_Locked",
	"ND_Width","ND_Height","ND_PosX","ND_PosY","ND_Scale"
)


function InfoDisplay:GetWindow()
	return InfoWindow
end 

function InfoDisplay:UpdateColor()
	if InfoWindow then 
		_ARTG:FrameBackdropColoring(InfoWindow,_ARTG.SV.GetVariable("ID_Anchor"),_ARTG.SV.GetVariable("ID_MatchBackdrop"),_ARTG.SV.GetVariable("ID_Backdrop"),
			_ARTG.SV.GetVariable("ID_Backdropr"),_ARTG.SV.GetVariable("ID_Backdropg"),_ARTG.SV.GetVariable("ID_Backdropb"),_ARTG.SV.GetVariable("ID_Backdropa")
		)

		local i = 1 --ignore disabled index
		for _,v in ipairs(AvyrRaidTools_DB["ID_Data"]) do 
			local SegmentWidth = 0
			if v:find("ET:") then 
				local Enable,r,g,b,a,Icon = _ARTG.SV.GetInformationDisplayItem("Unpack",v)
				if InfoWindow["InfoSegment"..i] and InfoWindow["InfoSegment"..i].TimerString then 
					InfoWindow["InfoSegment"..i].TimerString:SetTextColor(r,g,b,a)
				end 
				if Enable then 
					i = i + 1
				end
			elseif v:find("CR:") then 
				local Enable,r,g,b,a,Icon,Timer,Count = _ARTG.SV.GetInformationDisplayItem("Unpack",v)
				if InfoWindow["InfoSegment"..i] and InfoWindow["InfoSegment"..i].CountString then 
					InfoWindow["InfoSegment"..i].CountString:SetTextColor(r,g,b,a)
				end 
				if InfoWindow["InfoSegment"..i] and InfoWindow["InfoSegment"..i].CountStringSeperator then 
					InfoWindow["InfoSegment"..i].CountStringSeperator:SetTextColor(r,g,b,a)
				end 
				if InfoWindow["InfoSegment"..i] and InfoWindow["InfoSegment"..i].TimerString then 
					InfoWindow["InfoSegment"..i].TimerString:SetTextColor(r,g,b,a)
				end 
				if Enable then 
					i = i + 1
				end
			end 
		end 
	end 
end 

function InfoDisplay:UpdateDimensions()
	if InfoWindow then 
		local Width = _ARTG:FrameAnchoring(InfoWindow,_ARTG.SV.GetVariable("ID_Anchor"),_ARTG.SV.GetVariable("ID_AnchorPoint"),
			_ARTG.SV.GetVariable("ID_Locked"),_ARTG.SV.GetVariable("ID_MatchWidth"),_ARTG.SV.GetVariable("ID_Scale"),
			_ARTG.SV.GetVariable("ID_PosX"),_ARTG.SV.GetVariable("ID_PosY")
		)

		if not Width then 
			Width = _ARTG.SV.GetVariable("ID_Width") or Width
		end 
		InfoWindow:Size(Width,20)

		local IconSize = _ARTG.SV.GetVariable("ID_RowHeight") - 2 * Padding
		local Rows = 1
		local RowStartSegement = 1
		local TotalSegmentWidth = Padding
		local i = 1
		while InfoWindow["InfoSegment"..i] do 
			SegmentWidth = 0
			if InfoWindow["InfoSegment"..i].ID_SegementType == "ET" then 
				if InfoWindow["InfoSegment"..i].TimerIcon then 
					InfoWindow["InfoSegment"..i].TimerIcon:SetPoint("TOPLEFT")
					InfoWindow["InfoSegment"..i].TimerIcon:Size(IconSize,IconSize)
					SegmentWidth = IconSize
				end 
				InfoWindow["InfoSegment"..i].TimerString:SetHeight(IconSize)
				InfoWindow["InfoSegment"..i].TimerString:SetText("00:00")
				InfoWindow["InfoSegment"..i].TimerString:SetFontSizeOnly(IconSize - 2*Padding)
				if SegmentWidth > 0 then 
					SegmentWidth = SegmentWidth + Padding
				end 
				local StringLength = InfoWindow["InfoSegment"..i].TimerString:GetStringWidth()
				InfoWindow["InfoSegment"..i].TimerString:SetPoint("TOPRIGHT",InfoWindow["InfoSegment"..i],"TOPLEFT",SegmentWidth + StringLength,0)
				SegmentWidth = SegmentWidth + StringLength
			elseif InfoWindow["InfoSegment"..i].ID_SegementType == "CR" then
				if InfoWindow["InfoSegment"..i].TimerIcon then 
					InfoWindow["InfoSegment"..i].TimerIcon:SetPoint("TOPLEFT")
					InfoWindow["InfoSegment"..i].TimerIcon:Size(IconSize,IconSize)
					SegmentWidth = IconSize
				end 
				if InfoWindow["InfoSegment"..i].CountString then 
					InfoWindow["InfoSegment"..i].CountString:SetHeight(IconSize)
					InfoWindow["InfoSegment"..i].CountString:SetText("00")
					InfoWindow["InfoSegment"..i].CountString:SetFontSizeOnly(IconSize - 2*Padding) 
					if SegmentWidth > 0 then 
						SegmentWidth = SegmentWidth + Padding
					end 
					local StringLength = InfoWindow["InfoSegment"..i].CountString:GetStringWidth()
					InfoWindow["InfoSegment"..i].CountString:SetPoint("TOPRIGHT",InfoWindow["InfoSegment"..i],"TOPLEFT",SegmentWidth + StringLength,0)
					SegmentWidth = SegmentWidth + StringLength
				end 
				if InfoWindow["InfoSegment"..i].CountStringSeperator then 
					InfoWindow["InfoSegment"..i].CountStringSeperator:SetHeight(IconSize)
					InfoWindow["InfoSegment"..i].CountStringSeperator:SetText("-")
					InfoWindow["InfoSegment"..i].CountStringSeperator:SetFontSizeOnly(IconSize - 2*Padding)
					SegmentWidth = SegmentWidth + Padding
					InfoWindow["InfoSegment"..i].CountStringSeperator:SetPoint("TOPLEFT",SegmentWidth,0)
					SegmentWidth = SegmentWidth + InfoWindow["InfoSegment"..i].CountStringSeperator:GetStringWidth()
				end 
				if InfoWindow["InfoSegment"..i].TimerString then 
					InfoWindow["InfoSegment"..i].TimerString:SetHeight(IconSize)
					InfoWindow["InfoSegment"..i].TimerString:SetText("00:00")
					InfoWindow["InfoSegment"..i].TimerString:SetFontSizeOnly(IconSize - 2*Padding)
					if SegmentWidth > 0 then 
						SegmentWidth = SegmentWidth + Padding
					end 
					local StringLength = InfoWindow["InfoSegment"..i].TimerString:GetStringWidth()
					InfoWindow["InfoSegment"..i].TimerString:SetPoint("TOPRIGHT",InfoWindow["InfoSegment"..i],"TOPLEFT",SegmentWidth + StringLength,0)
					SegmentWidth = SegmentWidth + StringLength
				end 
			end 
			InfoWindow["InfoSegment"..i]:Size(SegmentWidth,IconSize)

			if TotalSegmentWidth + SegmentWidth + Padding > InfoWindow:GetWidth() then --first all segments in a row are built only then the row is assembled
				if RowStartSegement == i then --if only one segment in this row but it is to large (will result in it not looking clean but it wont bug out)
					InfoWindow["InfoSegment"..i]:ClearAllPoints()
					InfoWindow["InfoSegment"..i]:SetPoint("BOTTOM",InfoWindow,"TOP",0,-Rows*(IconSize + Padding))
					RowStartSegement = i + 1
					TotalSegmentWidth = Padding
				else 
					local Hos = (InfoWindow:GetWidth() - TotalSegmentWidth) / 2 + Padding
					for RowItemIndex = RowStartSegement,(i - 1) do  
						if InfoWindow["InfoSegment"..RowItemIndex] then 
							InfoWindow["InfoSegment"..RowItemIndex]:ClearAllPoints()
							InfoWindow["InfoSegment"..RowItemIndex]:SetPoint("BOTTOMLEFT",InfoWindow,"TOPLEFT",Hos,-Rows*(IconSize + Padding))
							Hos = Hos + InfoWindow["InfoSegment"..RowItemIndex]:GetWidth() + Padding
						end
					end
					RowStartSegement = i
					TotalSegmentWidth = TotalSegmentWidth + SegmentWidth + 2*Padding
					if not InfoWindow["InfoSegment"..(i + 1)] then 
						Rows = Rows + 1
						InfoWindow["InfoSegment"..i]:ClearAllPoints()
						InfoWindow["InfoSegment"..i]:SetPoint("BOTTOM",InfoWindow,"TOP",0,-Rows*(IconSize + Padding))
					end 
				end 
				if getn(AvyrRaidTools_DB["ID_Data"]) > i then
					Rows = Rows + 1
				end 
			else
				TotalSegmentWidth = TotalSegmentWidth + SegmentWidth + Padding
				if not InfoWindow["InfoSegment"..(i + 1)] then 
					local Hos = (InfoWindow:GetWidth() - TotalSegmentWidth) / 2 + Padding
					for RowItemIndex = RowStartSegement,i do  
						if InfoWindow["InfoSegment"..RowItemIndex] then 
							InfoWindow["InfoSegment"..RowItemIndex]:ClearAllPoints()
							InfoWindow["InfoSegment"..RowItemIndex]:SetPoint("BOTTOMLEFT",InfoWindow,"TOPLEFT",Hos,-Rows*(IconSize + Padding))
							Hos = Hos + InfoWindow["InfoSegment"..RowItemIndex]:GetWidth() + Padding
						end
					end
				end 
			end 
			
			i = i + 1
		end 
		InfoWindow:Size(nil,Rows*(IconSize + Padding) + Padding)
	end
end 

local ETTimerFontStringPointer 
local CRTimerFontStringPointer 
local CRTCountFontStringPointer 
function InfoDisplay:Load()
	InfoDisplay:Stop("ALL")

	ETTimerFontStringPointer = nil
	CRTimerFontStringPointer = nil
	CRTCountFontStringPointer = nil
	if InfoWindow then 
		InfoWindow:Release()
		InfoWindow = nil
	end 

	if not _ARTG:CheckLoadConditions("InfoDisplay") then 
		return nil 
	end 

	if not InfoWindow then 
		InfoWindow = Widgets:CreateFrame(UIParent)   
		InfoWindow:Size(160,20)
		InfoWindow:SetPoint("CENTER")  
		InfoWindow:SetClampedToScreen(true)
		InfoWindow:MakeMovable(not _ARTG.SV.GetVariable("ID_Locked"))  
		InfoWindow.OnMove = function(self)
			local _, _, _, x, y = self:GetPoint(1)
			_ARTG.SV.SaveVariable("ID_PosX", x*InfoWindow:GetEffectiveScale(), true)
			_ARTG.SV.SaveVariable("ID_PosY", y*InfoWindow:GetEffectiveScale())
			--_ARTG:FrameStopMoving(Frame)
		end
		--[[InfoWindow.OnMoveStart = function(self)
			_ARTG:FrameStartMoving(self)
		end]]
	end 

	local i = 1
	for _,v in ipairs(AvyrRaidTools_DB["ID_Data"]) do 
		local SegmentWidth = 0
		if v:find("ET:") then 
			local Enable,r,g,b,a,Icon = _ARTG.SV.GetInformationDisplayItem("Unpack",v)
			if Enable then 
				InfoWindow["InfoSegment"..i] = Widgets:CreateFrame(InfoWindow)
				InfoWindow["InfoSegment"..i].ID_SegementType = "ET"
				if Icon then 
					InfoWindow["InfoSegment"..i].TimerIcon = Widgets:CreateFrame(InfoWindow["InfoSegment"..i])
					InfoWindow["InfoSegment"..i].TimerIcon:SetThemedBackdrop()
					InfoWindow["InfoSegment"..i].TimerIcon:SetIcon("TexturePath",1391676,"LeftCoord",0.1,"RightCoord",0.9,"TopCoord",0.1,"BottomCoord",0.9)
				end 
				InfoWindow["InfoSegment"..i].TimerString = Widgets:FetchFontString(InfoWindow["InfoSegment"..i])
				--InfoWindow["InfoSegment"..i].TimerString:SetTextColor(r,g,b,a)
				ETTimerFontStringPointer = InfoWindow["InfoSegment"..i].TimerString
				i = i + 1
			end 
		elseif v:find("CR:") then 
			local Enable,r,g,b,a,Icon,Timer,Count = _ARTG.SV.GetInformationDisplayItem("Unpack",v)
			if Enable then 
				InfoWindow["InfoSegment"..i] = Widgets:CreateFrame(InfoWindow)
				InfoWindow["InfoSegment"..i].ID_SegementType = "CR"
				if Icon then 
					InfoWindow["InfoSegment"..i].TimerIcon = Widgets:CreateFrame(InfoWindow["InfoSegment"..i])
					InfoWindow["InfoSegment"..i].TimerIcon:SetThemedBackdrop()
					InfoWindow["InfoSegment"..i].TimerIcon:SetIcon("TexturePath",136080,"LeftCoord",0.1,"RightCoord",0.9,"TopCoord",0.1,"BottomCoord",0.9)
					SegmentWidth = IconSize
				end 
				if Count then 
					InfoWindow["InfoSegment"..i].CountString = Widgets:FetchFontString(InfoWindow["InfoSegment"..i])
					CRTCountFontStringPointer = InfoWindow["InfoSegment"..i].CountString
					--InfoWindow["InfoSegment"..i].CountString:SetTextColor(r,g,b,a)
					if Timer then 
						InfoWindow["InfoSegment"..i].CountStringSeperator = Widgets:FetchFontString(InfoWindow["InfoSegment"..i])
						--InfoWindow["InfoSegment"..i].CountStringSeperator:SetTextColor(r,g,b,a)
					end 
				end 
				if Timer then 
					InfoWindow["InfoSegment"..i].TimerString = Widgets:FetchFontString(InfoWindow["InfoSegment"..i])
					CRTimerFontStringPointer = InfoWindow["InfoSegment"..i].TimerString
					--InfoWindow["InfoSegment"..i].TimerString:SetTextColor(r,g,b,a)
				end 
				i = i + 1
			end            
		end 
	end 
	InfoDisplay:UpdateDimensions()
	InfoDisplay:UpdateColor()
end 

--local Timer = CreateFrame("FRAME")
--local Time = 0
function InfoDisplay:Start()
		--[[
	if InfoWindow then
		Time = 0
		Timer:SetScript("OnUpdate",function(self,elapsed)
			if C_ChallengeMode.IsChallengeModeActive() or IsEncounterInProgress() then 
				Time = Time + elapsed
				if ETTimerFontStringPointer then    
					ETTimerFontStringPointer:SetText(_ARTG.ConvertToTime(Time))
				end 
				if CRTimerFontStringPointer or CRTCountFontStringPointer then 
					local Charges, _, Started, Duration = GetSpellCharges(20484)
					if CRTimerFontStringPointer and Duration then 
						if Charges == 5 then 
							CRTimerFontStringPointer:SetText("00:00")
						else
							CRTimerFontStringPointer:SetText(_ARTG.ConvertToTime(Duration + Started - GetTime()))
						end
					end
					if CRTCountFontStringPointer then 
						CRTCountFontStringPointer:SetText(Charges or "0")
					end
				end
			else 
				Timer:SetScript("OnUpdate",nil)
			end 
		end)
	end ]]
end 

InfoDisplay.OnUpdate = function(encounterTime)
	if InfoWindow then
		if C_ChallengeMode.IsChallengeModeActive() or IsEncounterInProgress() then 
			if ETTimerFontStringPointer then    
				ETTimerFontStringPointer:SetText(_ARTG.ConvertToTime(encounterTime))
			end 
			if CRTimerFontStringPointer or CRTCountFontStringPointer then 
				local Charges, _, Started, Duration = GetSpellCharges(20484)
				if CRTimerFontStringPointer then 
					if Charges == 5 or not Duration then 
						CRTimerFontStringPointer:SetText("00:00")
					else
						CRTimerFontStringPointer:SetText(_ARTG.ConvertToTime(Duration + Started - GetTime()))
					end
				end
				if CRTCountFontStringPointer then 
					CRTCountFontStringPointer:SetText(Charges or "0")
				end
			end
		end
	end 
end

--[[
					if NoteDisplayWindow.NoteHeader.Timer then 
						NoteDisplayWindow.NoteHeader.Timer:SetText(_ARTG.ConvertToTime(_ARTG.EncounterTime))
					end 
					local Charges, _, Started, Duration = GetSpellCharges(20484)
					if NoteDisplayWindow.NoteHeader.CRTimer and Duration and Started then 
						NoteDisplayWindow.NoteHeader.CRTimer:SetText(_ARTG.ConvertToTime(Duration + Started - GetTime()))
					end 
					if NoteDisplayWindow.NoteHeader.CRCount then 
						NoteDisplayWindow.NoteHeader.CRCount:SetText((Charges or "0"))
					end 
]]

function InfoDisplay:Stop()

end

