local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local insert, remove = table.insert, table.remove
local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")

_ARTG.SV = {}

--[[
_ARTG.SV.SettingsInfo = {
	["G_Enable"] = {"boolean","Enable addon","Enables/disables the vast majority of the addons capabilities."}
}]]

_ARTG.SV.Components = {
	{"Minimap icon", "MI_Enable"},
	{"Note display", "ND_Enable"}
}

local DefaultSettings = {
	--global
	["G_Enable"] = true,

	["G_NormalColorr"] = 1,
	["G_NormalColorg"] = 1,
	["G_NormalColorb"] = 1,

	["G_HighlightColorr"] = 1,
	["G_HighlightColorg"] = 0.82,
	["G_HighlightColorb"] = 0,

	["G_BackdropColorr"] = 0.1,
	["G_BackdropColorg"] = 0.1,
	["G_BackdropColorb"] = 0.1,
	["G_BackdropColora"] = 0.9,

	["G_BorderColorr"] = 0,
	["G_BorderColorg"] = 0,
	["G_BorderColorb"] = 0,
	["G_BorderColora"] = 1,

	--Menu
	["GM_PosX"] = 0,
	["GM_PosY"] = 0,
	["GM_Scale"] = 1,
	["GM_Locked"] = false,

	--minimap icon
	["MI_PosX"] = -12,
	["MI_PosY"] = -80,
	["MI_Enable"] = true,

	--Editor Stuff
	["NE_PosX"] = 0,
	["NE_PosY"] = 0,
	["NE_Scale"] = 1,
	["NE_FullScreen"] = false,

	--note display options
	["ND_Enable"] = true,
	["ND_Width"] = 200,
	["ND_Height"] = 300,

	["ND_Locked"] = false,
	["ND_PosX"] = 0,
	["ND_PosY"] = 0,
	["ND_Scale"] = 1,

	["ND_PP_Enable"] = true,
	["ND_PP_Always"] = false,
	["ND_PP_CTRL"] = false,
	["ND_PP_ALT"] = false,
	["ND_PP_SHIFT"] = true,

	--["ND_NoNoteHide"] = true,

	["ND_NoteFontr"] = 1,
	["ND_NoteFontg"] = 1,
	["ND_NoteFontb"] = 1,
	["ND_NoteFonta"] = 1,

	["ND_ConditionFontr"] = 1,
	["ND_ConditionFontg"] = 0.82,
	["ND_ConditionFontb"] = 0,
	["ND_ConditionFonta"] = 1,

	["ND_Backdrop"] = true,
	["ND_Backdropr"] = 0,
	["ND_Backdropg"] = 0,
	["ND_Backdropb"] = 0,
	["ND_Backdropa"] = 0.33,

	["ND_HighlightCurrent"] = true,
	["ND_HighlightCurrentr"] = 1,
	["ND_HighlightCurrentg"] = 0.87,
	["ND_HighlightCurrentb"] = 0,
	["ND_HighlightCurrenta"] = 0.25,

	["ND_HighlightNext"] = true,
	["ND_HighlightNextr"] = 0.2,
	["ND_HighlightNextg"] = 0.2,
	["ND_HighlightNextb"] = 0.87,
	["ND_HighlightNexta"] = 0.25,

	["ND_TransitionTime"] = 0.5,
	["ND_SmoothScroll"] = true,

	--Keyword stuff
	["ND_EnableKeywords"] = true,
	
	["ND_KeywordsBorderHighlight"] = true,
	["ND_KeywordsBorderHighlightr"] = 1,
	["ND_KeywordsBorderHighlightg"] = 0.87,
	["ND_KeywordsBorderHighlightb"] = 0,
	["ND_KeywordsBorderHighlighta"] = 1,

	["ND_EnableSound"] = false,
	["ND_BaseSound"] = 12867,

	--info display stuff
	["ID_Enable"] = true,
	["ID_Scale"] = 1,
	["ID_RowHeight"] = 20,
	["ID_Width"] = 200,
	["ID_Locked"] = false,

	["ID_Anchor"] = "NOTEDISPLAY",
	["ID_AnchorPoint"] = "TOP",
	["ID_MatchWidth"] = true, 
	["ID_PosX"] = 0,
	["ID_PosY"] = 0,

	["ID_MatchBackdrop"] = true,
	["ID_Backdrop"] = true,
	["ID_Backdropr"] = 0,
	["ID_Backdropg"] = 0,
	["ID_Backdropb"] = 0,
	["ID_Backdropa"] = 0.33,

	--healer mana display
	["HMD_Enable"] = true,
	["HMD_Scale"] = 1,
	["HMD_BarHeight"] = 20,
	["HMD_Width"] = 220,
	["HMD_Locked"] = false,

	["HMD_Anchor"] = "NOTEDISPLAY",
	["HMD_AnchorPoint"] = "BOTTOM",
	["HMD_MatchWidth"] = true, 
	["HMD_PosX"] = 0,
	["HMD_PosY"] = 0,
	--["HMD_FrequentUpdate"] = false,
	["HMD_IgnoreOwn"] = false,
	["HMD_MatchZone"] = true,

	["HMD_MatchBackdrop"] = true,
	["HMD_Backdrop"] = true,
	["HMD_Backdropr"] = 0,
	["HMD_Backdropg"] = 0,
	["HMD_Backdropb"] = 0,
	["HMD_Backdropa"] = 0.33,

	["HMD_BarClassColor"] = false,
	["HMD_BarColorr"] = 0.25,
	["HMD_BarColorg"] = 0.25,
	["HMD_BarColorb"] = 1,
	["HMD_BarColora"] = 1,
	
	["HMD_BarFontColorr"] = 1,
	["HMD_BarFontColorg"] = 0.82,
	["HMD_BarFontColorb"] = 0,
	["HMD_BarFontColora"] = 1,
}
local RenamedOptions = {
	{"ND_Header","ID_Enable"},
	{"ND_HeaderScale","ID_Scale"},
	{"ND_HeaderAnchor","ID_AnchorPoint"},
}

local DeletedOptions = {
	"ND_AlwaysLoad",
	"ID_AlwaysLoad",
	"HMD_AlwaysLoad",    
	"ND_NoNoteLoad",
	"ID_NoNoteLoad",
	"HMD_NoNoteLoad",    
	"ND_RaidLoad",
	"ID_RaidLoad",
	"HMD_RaidLoad",
	"ND_RaidInLoad",
	"ID_RaidInLoad",
	"HMD_RaidInLoad",    
	"ND_GuildRaidInLoad",
	"ID_GuildRaidInLoad",
	"HMD_GuildRaidInLoad",    
	"ND_HealerLoad",
	"ID_HealerLoad",
	"HMD_HealerLoad",    
	"ND_DDLoad",
	"ID_DDLoad",
	"HMD_DDLoad",    
	"ND_TankLoad",
	"ID_TankLoad",
	"HMD_TankLoad",    
	"ND_InstanceLoad",
	"ID_InstanceLoad",
	"HMD_InstanceLoad",    
	"ND_KeystoneLoad",
	"ID_KeystoneLoad",
	"HMD_KeystoneLoad",
}

local DefaultLoadOptions = {
	"ND|0:1:HEALER:RAID_INSTANCE:",
	"ID:HMD|0:0:HEALER:RAID_INSTANCE:",
	"ID|0:0:DAMAGER:RAID_INSTANCE:",
	"ID:HMD|0:0:TANK:RAID_INSTANCE:",
	"HMD|0:0:TANK:!OPEN_WORLD:"
}

local Loaded = false

_ARTG.SV.Load = function(self)
	AvyrRaidTools_DB = AvyrRaidTools_DB or {}
	AvyrRaidTools_DB.Notes = AvyrRaidTools_DB.Notes or {}
	AvyrRaidTools_DB.CurrentNote = AvyrRaidTools_DB.CurrentNote or {}

	--old editor stuff
	AvyrRaidTools_DB.MemberNames = AvyrRaidTools_DB.MemberNames or {}
	AvyrRaidTools_DB.MemberNames.LastRaid = AvyrRaidTools_DB.MemberNames.LastRaid or {}
	AvyrRaidTools_DB.MemberNames.LastUsed = AvyrRaidTools_DB.MemberNames.LastUsed or {}

	AvyrRaidTools_DB.EditorCooldowns = AvyrRaidTools_DB.EditorCooldowns or {}
	AvyrRaidTools_DB.EditorCooldowns.Favorites = AvyrRaidTools_DB.EditorCooldowns.Favorites or {}
	AvyrRaidTools_DB.EditorCooldowns.LastCreated = AvyrRaidTools_DB.EditorCooldowns.LastCreated or {}

	AvyrRaidTools_DB.LoadConditions = AvyrRaidTools_DB.LoadConditions or _ARTG.DataFuncs.cloneTable(DefaultLoadOptions)

	AvyrRaidTools_DB.ID_Data = AvyrRaidTools_DB.ID_Data or {
		"ET:1:1:0.81177004800816:0.067562568126462:1:1:1:1", -- [1]
		"CR:1:1:0.87:0:1:1", -- [2]
	}

	AvyrRaidTools_DB.KeywordsCD = AvyrRaidTools_DB.KeywordsCD or {}
	AvyrRaidTools_DB.Keywords = AvyrRaidTools_DB.Keywords or {}
	AvyrRaidTools_DB.KnownChars = AvyrRaidTools_DB.KnownChars or {}

	--renamed options
	for i,v in ipairs(RenamedOptions) do 
		if type(AvyrRaidTools_DB[v[1]]) ~= "nil" then 
			AvyrRaidTools_DB[v[2]] = AvyrRaidTools_DB[v[1]]
			AvyrRaidTools_DB[v[1]] = nil
		end
	end 

	for i,v in ipairs(DeletedOptions) do 
		if type(AvyrRaidTools_DB[v]) ~= "nil" then 
			AvyrRaidTools_DB[v] = nil
		end
	end 

	if type(AvyrRaidTools_DB["ND_EncounterTimer"]) ~= "nil" then 
		_ARTG.SV.EditInformationDisplayItem("EncounterTimer","Enable",AvyrRaidTools_DB["ND_EncounterTimer"])
		AvyrRaidTools_DB["ND_EncounterTimer"] = nil
		if type(AvyrRaidTools_DB["ND_EncounterTimerIcon"]) ~= "nil" then 
			_ARTG.SV.EditInformationDisplayItem("EncounterTimer","Icon",AvyrRaidTools_DB["ND_EncounterTimer"])
			AvyrRaidTools_DB["ND_EncounterTimerIcon"] = nil
		end 
		if type(AvyrRaidTools_DB["ND_EncounterTimerFontr"]) ~= "nil" and type(AvyrRaidTools_DB["ND_EncounterTimerFontg"]) ~= "nil" and 
		type(AvyrRaidTools_DB["ND_EncounterTimerFontb"]) ~= "nil" and type(AvyrRaidTools_DB["ND_EncounterTimerFonta"]) ~= "nil" then 
			_ARTG.SV.EditInformationDisplayItem("EncounterTimer","Color",AvyrRaidTools_DB["ND_EncounterTimerFontr"],AvyrRaidTools_DB["ND_EncounterTimerFontg"], 
			AvyrRaidTools_DB["ND_EncounterTimerFontb"],AvyrRaidTools_DB["ND_EncounterTimerFonta"])
			AvyrRaidTools_DB["ND_EncounterTimerFontr"] = nil;AvyrRaidTools_DB["ND_EncounterTimerFontg"] = nil
			AvyrRaidTools_DB["ND_EncounterTimerFontb"] = nil;AvyrRaidTools_DB["ND_EncounterTimerFonta"] = nil
		end 
	end 

	if type(AvyrRaidTools_DB["ND_CRCounter"]) ~= "nil" then 
		_ARTG.SV.EditInformationDisplayItem("CombatRezz","Enable",AvyrRaidTools_DB["ND_CRCounter"])
		AvyrRaidTools_DB["ND_CRCounter"] = nil
		if type(AvyrRaidTools_DB["ND_CRCounterIcon"]) ~= "nil" then 
			_ARTG.SV.EditInformationDisplayItem("CombatRezz","Icon",AvyrRaidTools_DB["ND_CRCounterIcon"])
			AvyrRaidTools_DB["ND_CRCounterIcon"] = nil
		end 
		if type(AvyrRaidTools_DB["ND_CRCounterTimer"]) ~= "nil" then 
			_ARTG.SV.EditInformationDisplayItem("CombatRezz","Timer",AvyrRaidTools_DB["ND_CRCounterTimer"])
			AvyrRaidTools_DB["ND_CRCounterTimer"] = nil
		end 
		if type(AvyrRaidTools_DB["ND_CRCounterFontr"]) ~= "nil" and type(AvyrRaidTools_DB["ND_CRCounterFontg"]) ~= "nil" and 
		type(AvyrRaidTools_DB["ND_CRCounterFontb"]) ~= "nil" and type(AvyrRaidTools_DB["ND_CRCounterFonta"]) ~= "nil" then 
			_ARTG.SV.EditInformationDisplayItem("CombatRezz","Color",AvyrRaidTools_DB["ND_CRCounterFontr"],AvyrRaidTools_DB["ND_CRCounterFontg"], 
			AvyrRaidTools_DB["ND_CRCounterFontb"],AvyrRaidTools_DB["ND_CRCounterFonta"])
			AvyrRaidTools_DB["ND_CRCounterFontr"] = nil;AvyrRaidTools_DB["ND_CRCounterFontg"] = nil
			AvyrRaidTools_DB["ND_CRCounterFontb"] = nil;AvyrRaidTools_DB["ND_CRCounterFonta"] = nil
		end 
	end 

	for i,v in pairs(DefaultSettings) do 
		if type(AvyrRaidTools_DB[i]) == "nil" then 
			AvyrRaidTools_DB[i] = v
		end 
	end 

	--_ARTG.CheckNoteVersion(AvyrRaidTools_DB.CurrentNote)

	if AvyrRaidTools_DB.CurrentNote and AvyrRaidTools_DB.CurrentNote.Info then 
		local Info = {strsplit(":",AvyrRaidTools_DB.CurrentNote.Info)}
		AvyrRaidTools_DB.CurrentNote.Expansion = tonumber(Info[1])
		AvyrRaidTools_DB.CurrentNote.Raid = tonumber(Info[2])
		AvyrRaidTools_DB.CurrentNote.Boss = tonumber(Info[3])
		local Version = Info[4]
		if type(Version) == "nil" then 
			for i,v in ipairs(AvyrRaidTools_DB.CurrentNote.Data) do 
				v[2] = v[2]:gsub("!cd","\023")
			end 
		end
		AvyrRaidTools_DB.CurrentNote.Info = nil
	end 


	if not AvyrRaidTools_DB.Notes.Version then 
		local NewNotes = {}
		for i,Note in ipairs(AvyrRaidTools_DB.Notes) do 
			--_ARTG.CheckNoteVersion(Note)
			if Note.Info then 
				local Info = {strsplit(":",Note.Info)}
				local Expansion = tonumber(Info[1])
				local Raid = tonumber(Info[2])
				local Boss = tonumber(Info[3])
				local Version = Info[4]
				if type(Version) == "nil" then 
					for i,v in ipairs(Note.Data) do 
						v[2] = v[2]:gsub("!cd","\023")
					end 
				end
				if Expansion then 
					NewNotes[Expansion] = NewNotes[Expansion] or {}
					if Raid then 
						NewNotes[Expansion][Raid] = NewNotes[Expansion][Raid] or {}
						if Boss then 
							NewNotes[Expansion][Raid][Boss] = NewNotes[Expansion][Raid][Boss] or {}
							insert(NewNotes[Expansion][Raid][Boss],{
								Name = Note.Name,
								Description = Note.Description,
								Data = Note.Data,
							})
						else 
							NewNotes[Expansion][Raid]["Other"] = NewNotes[Expansion][Raid]["Other"] or {}
							insert(NewNotes[Expansion][Raid]["Other"],{
								Name = Note.Name,
								Description = Note.Description,
								Data = Note.Data,
							})
						end
					else 
						NewNotes[Expansion]["Other"] = NewNotes[Expansion]["Other"] or {}
						insert(NewNotes[Expansion]["Other"],{
							Name = Note.Name,
							Description = Note.Description,
							Data = Note.Data,
						})
					end 
				else 
					NewNotes["Other"] = NewNotes["Other"] or {}
					insert(NewNotes["Other"],{
						Name = Note.Name,
						Description = Note.Description,
						Data = Note.Data,
					})
				end 
			end 
		end 
		AvyrRaidTools_DB.Notes = NewNotes
		AvyrRaidTools_DB.Notes.Version = 1
	end 
	Loaded = true 

	
	Widgets:SetTheme("Normal",AvyrRaidTools_DB["G_NormalColorr"],AvyrRaidTools_DB["G_NormalColorg"],AvyrRaidTools_DB["G_NormalColorb"])
	Widgets:SetTheme("Highlight",AvyrRaidTools_DB["G_HighlightColorr"],AvyrRaidTools_DB["G_HighlightColorg"],AvyrRaidTools_DB["G_HighlightColorb"])
	Widgets:SetTheme("Border",AvyrRaidTools_DB["G_BorderColorr"],AvyrRaidTools_DB["G_BorderColorg"],AvyrRaidTools_DB["G_BorderColorb"],AvyrRaidTools_DB["G_BorderColora"])
	Widgets:SetTheme("Backdrop",AvyrRaidTools_DB["G_BackdropColorr"],AvyrRaidTools_DB["G_BackdropColorg"],AvyrRaidTools_DB["G_BackdropColorb"],AvyrRaidTools_DB["G_BackdropColora"])

	_ARTG.MinimapIcon:Refresh()
	_ARTG.NoteDisplay:Load()
end 

_ARTG.SV.ResetSettings = function()
	for i,v in pairs(DefaultSettings) do 
		AvyrRaidTools_DB[i] = v
	end 
	_ARTG.SV.SaveVariable("ALL")
end 

--local Centerx, Centery = UIParent:GetCenter();
_ARTG.SV.GetVariable = function(varName)
	if Loaded then 
		return AvyrRaidTools_DB[varName]
	end 
end 

local SVCallbacks = {}

_ARTG.SV.RegisterSVCallback = function(func,...)
	for i,v in ipairs({...}) do
		SVCallbacks[v] = SVCallbacks[v] or {}
		insert(SVCallbacks[v],func)
	end
end

_ARTG.SV.CallSVCallbacks = function(varName,varValue)
	if SVCallbacks[varName] then 
		 for i,v in ipairs(SVCallbacks[varName]) do 
			v(varName,varValue)
		end
	end
end

_ARTG.SV.SaveVariable = function(varName,varValue, SurppressUpdate) 
	if varName ~= "ALL" then 
		AvyrRaidTools_DB[varName] = varValue
	end 
	
	--variable call backs
	if not SurppressUpdate then 
		_ARTG.SV.CallSVCallbacks(varName,varValue)

		if varName == "ALL" then 
			if _ARTG.OpenMenu then 
				if _ARTG.OpenMenu == "Editor" then 
					_ARTG.Editor:Call("Close")
					_ARTG.Editor:Call("Open")
				elseif _ARTG.OpenMenu == "Menu" then 
					_ARTG.OptionsMenu:Call("Close");
					_ARTG.OptionsMenu:Call("Open");
				elseif _ARTG.OpenMenu == "QuickSelect" then  
					_ARTG.OptionsMenu:QuickCall("Close");
					_ARTG.OptionsMenu:QuickCall("Open");                
				end 
			end 
		end 
	end 
end 

_ARTG.SV.GetInformationDisplayItem = function(Action,String)
	if Action == "QuickCheck" then 

	elseif Action == "Unpack" then 
		local Data = {strsplit(":",String)}
		if Data[1] == "ET" then 
			--Type,Enable,r,g,b,a,Icon
			local Enable,r,g,b,a,Icon = true,1,1,1,1,true
			if Data[2] and Data[2] ~= "1" then 
				Enable = false
			end 
			if Data[3] and tonumber(Data[3]) then 
				r = tonumber(Data[3])
			end 
			if Data[4] and tonumber(Data[4]) then 
				g = tonumber(Data[4])
			end 
			if Data[5] and tonumber(Data[5]) then 
				b = tonumber(Data[5])
			end 
			if Data[6] and tonumber(Data[6]) then 
				a = tonumber(Data[6])
			end
			if Data[7] and Data[7] ~= "1" then 
				Icon = false
			end  
			return Enable,r,g,b,a,Icon
		elseif Data[1] == "CR" then 
			--Type,Enable,r,g,b,a,Icon,Timer,Count
			local Enable,r,g,b,a,Icon,Timer,Count = true,1,1,1,1,true,true,true
			if Data[2] and Data[2] ~= "1" then 
				Enable = false
			end 
			if Data[3] and tonumber(Data[3]) then 
				r = tonumber(Data[3])
			end 
			if Data[4] and tonumber(Data[4]) then 
				g = tonumber(Data[4])
			end 
			if Data[5] and tonumber(Data[5]) then 
				b = tonumber(Data[5])
			end 
			if Data[6] and tonumber(Data[6]) then 
				a = tonumber(Data[6])
			end
			if Data[7] and Data[7] ~= "1" then 
				Icon = false
			end  
			if Data[8] and Data[8] ~= "1" then 
				Timer = false
			end  
			if Data[9] and Data[9] ~= "1" then 
				Count = false
			end  
			return Enable,r,g,b,a,Icon,Timer,Count
		end 
	end
end 

--no action will create item if it doesnt exist
_ARTG.SV.EditInformationDisplayItem = function(Name,Action,...)
	local ChangesMade = false
	local Type
	if Name  == "EncounterTimer" or Name == "ET" then 
		Type = "ET"
	elseif Name == "CombatRezz" or Name == "CR" then 
		Type = "CR"
	end 
	if Type then 
		local CurrentIndex
		for i,v in ipairs(AvyrRaidTools_DB["ID_Data"]) do 
			if v:find(Type..":") then 
				CurrentIndex = i
				break 
			end 
		end 
		if not CurrentIndex then 
			if Type == "CR" then 
				insert(AvyrRaidTools_DB.ID_Data,"CR:")
			elseif Type == "ET" then 
				insert(AvyrRaidTools_DB.ID_Data,"ET:")
			end 
			CurrentIndex = getn(AvyrRaidTools_DB.ID_Data)
		end 

		if Action then 
			if Action == "Position" then 
				local Increment = ...
				if type(Increment) == "number" and Increment ~= 0 then 
					local NewPos = CurrentIndex + Increment
					if CurrentIndex ~= NewPos and NewPos > 0 and NewPos <= getn(AvyrRaidTools_DB.ID_Data) then 
						local tempValue = AvyrRaidTools_DB.ID_Data[CurrentIndex]
						remove(AvyrRaidTools_DB.ID_Data,CurrentIndex)
						insert(AvyrRaidTools_DB.ID_Data,NewPos,tempValue)
						ChangesMade = true 
					end
				end
			end 
			if Type == "ET" then 
				local ET,Enable,r,g,b,a,Icon = strsplit(":",AvyrRaidTools_DB.ID_Data[CurrentIndex])
				Enable = Enable or "1"; r = r or "1"; g = g or "0.87"; b = b or "0"; a = a or "1"; Icon = Icon or "1"
				if Action == "Enable" then 
					local EnableInput = ...
					Enable = EnableInput and "1" or "0"
					ChangesMade = true 
				elseif Action == "Icon" then 
					local EnableIcon = ...
					Icon = EnableIcon and "1" or "0"
					ChangesMade = true 
				elseif Action == "Color" then 
					local newr,newg,newb,newa = ...
					r = type(newr) == "number" and newr or r
					g = type(newg) == "number" and newg or g
					b = type(newb) == "number" and newb or b
					a = type(newa) == "number" and newa or a
					ChangesMade = true 
				end 
				AvyrRaidTools_DB.ID_Data[CurrentIndex] = ET..":"..Enable..":"..r..":"..g..":"..b..":"..a..":"..Icon
			elseif Type == "CR" then 
				local ET,Enable,r,g,b,a,Icon,Timer,Count = strsplit(":",AvyrRaidTools_DB.ID_Data[CurrentIndex])
				Enable = Enable or "1"; r = r or "1"; g = g or "0.87"; b = b or "0"; a = a or "1"; Icon = Icon or "1"; Timer = Timer or "1"; Count = Count or "1"
				if Action == "Enable" then 
					local EnableInput = ...
					Enable = EnableInput and "1" or "0"
					ChangesMade = true 
				elseif Action == "Icon" then 
					local EnableIcon = ...
					Icon = EnableIcon and "1" or "0"
					ChangesMade = true 
				elseif Action == "Color" then 
					local newr,newg,newb,newa = ...
					r = type(newr) == "number" and newr or r
					g = type(newg) == "number" and newg or g
					b = type(newb) == "number" and newb or b
					a = type(newa) == "number" and newa or a
					ChangesMade = true 
				elseif Action == "Timer" then 
					local EnableTimer = ...
					Timer = EnableTimer and "1" or "0"
					ChangesMade = true 
				elseif Action == "Count" then 
					local EnableCount = ...
					Count = EnableCount and "1" or "0"
					ChangesMade = true 
				end 
				AvyrRaidTools_DB.ID_Data[CurrentIndex] = ET..":"..Enable..":"..r..":"..g..":"..b..":"..a..":"..Icon..":"..Timer..":"..Count   
			end   
		end
	end
	if ChangesMade then 
		_ARTG.InfoDisplay:Load()
		_ARTG.OptionsMenu:Refresh("INFODISPLAY_COMPONENTS",true)
	end 
end

function _ARTG.SV:AddMyCooldownKeyword(Type,arg1,arg2,arg3,arg4)
	local Term,CaseMatch,OverrideSound
	local CD
	local ChangesMade = false
	if Type == "Keyword" and type(arg1) ~= "nil" then 
		Term,CaseMatch,OverrideSound = arg1,arg2,arg3
		if Term then 
			for i,v in ipairs(AvyrRaidTools_DB.Keywords) do 
				if v.Term == Term then 
					return 
				end 
			end 
			insert(AvyrRaidTools_DB.Keywords,{Term = Term, CM  = CaseMatch, Sound = OverrideSound})
			ChangesMade = "KW"
		end 
	elseif Type == "CD" and type(arg1) ~= "nil" and type(arg2) ~= "nil" then 
		Term = _ARTG.ConvertCD(arg1,arg2,"")
		CaseMatch,OverrideSound = arg3,arg4
		if Term then 
			for i,v in ipairs(AvyrRaidTools_DB.KeywordsCD) do 
				if v.Term == Term then 
					return 
				end 
			end 
			insert(AvyrRaidTools_DB.KeywordsCD,{Term = Term, CM  = CaseMatch, Sound = OverrideSound})
			ChangesMade = "CD"
		end 
	end 
	if ChangesMade then 
		_ARTG.NoteDisplay:Load()
		if ChangesMade == "KW" then
			_ARTG.OptionsMenu:Refresh("DISPLAY_KEYWORDS_KEYWORDS",true)
		elseif ChangesMade == "CD" then
			_ARTG.OptionsMenu:Refresh("DISPLAY_KEYWORDS_CDS",true)
		end
	end 
end 

function _ARTG.SV:EditMyCooldownKeyword(Type,Action,...)
	local ChangesMade = false
	if Action == "Remove" then 
		local Index = ...
		if Type == "Keyword" then 
			remove(AvyrRaidTools_DB.Keywords,Index)
			ChangesMade = "KW"
		elseif Type == "CD" then 
			remove(AvyrRaidTools_DB.KeywordsCD,Index)
			ChangesMade = "CD"
		end 
	elseif Action == "Edit" then 
		--Term, CM, Sound
		local Index,VarName,VarValue = ...
		if Type == "Keyword" and AvyrRaidTools_DB.Keywords[Index] then 
			AvyrRaidTools_DB.Keywords[Index][VarName] = VarValue
			ChangesMade = "KW"
		elseif Type == "CD" and AvyrRaidTools_DB.KeywordsCD[Index] then 
			AvyrRaidTools_DB.KeywordsCD[Index][VarName] = VarValue
			ChangesMade = "CD"
		end    
	end 
	if ChangesMade then 
		_ARTG.NoteDisplay:Load()
		if ChangesMade == "KW" then
			_ARTG.OptionsMenu:Refresh("DISPLAY_KEYWORDS_KEYWORDS",true)
		elseif ChangesMade == "CD" then
			_ARTG.OptionsMenu:Refresh("DISPLAY_KEYWORDS_CDS",true)
		end
	end 
end 

function _ARTG.SV:IsCooldownKeyword(Type,Word)
	if Type == "Keyword" then 
		for i,v in ipairs(AvyrRaidTools_DB.Keywords) do
			if v.Term == Word then 
				return true 
			end
		end
	elseif Type == "CD" then 
		for i,v in ipairs(AvyrRaidTools_DB.KeywordsCD) do
			if v.Term == Word then 
				return true 
			end
		end
	end 
	return false 
end


_ARTG.SV.PrepareCharacter = function()
	local Name,Realm = UnitFullName("player")
	if not AvyrRaidTools_DB.KnownChars[Name.."-"..Realm] then 
		AvyrRaidTools_DB.KnownChars[Name.."-"..Realm] = {}
	end 
	--keyword stuff
	if not AvyrRaidTools_DB.KnownChars[Name.."-"..Realm].Keywords then 
		_ARTG.SV:AddMyCooldownKeyword("Keyword",Name)
		_ARTG.SV:AddMyCooldownKeyword("Keyword",Name.."-"..Realm)
		local _,_,classID = UnitClass("Player")
		if _ARTG.Data.Cooldowns[classID..""] then 
			for _,CDID in ipairs(_ARTG.Data.Cooldowns[classID..""]) do 
				_ARTG.SV:AddMyCooldownKeyword("CD",CDID,Name)
				_ARTG.SV:AddMyCooldownKeyword("CD",CDID,Name.."-"..Realm)
			end 
		end 
		for i = 1,GetNumSpecializations() do 
			if _ARTG.Data.Cooldowns[classID.."-"..GetSpecializationInfo(i)] then 
				for _,CDID in ipairs(_ARTG.Data.Cooldowns[classID.."-"..GetSpecializationInfo(i)]) do 
					_ARTG.SV:AddMyCooldownKeyword("CD",CDID,Name)
					_ARTG.SV:AddMyCooldownKeyword("CD",CDID,Name.."-"..Realm)
				end 

			end 
		end 
		AvyrRaidTools_DB.KnownChars[Name.."-"..Realm].Keywords = true 
	end 
	--profile stuff for later maybe
end 

_ARTG.SV.CheckNoteExists = function(Expansion,Raid,Boss,Index,ReturnDirectory)
	if (type(Expansion) == "string" or type(Expansion) == "number") and type(Index) == "number" then 
		if Expansion == "Deprecated" or Expansion == "Other" then 
			if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Index] then 
				if ReturnDirectory then 
					return AvyrRaidTools_DB.Notes[Expansion]
				else 
					return AvyrRaidTools_DB.Notes[Expansion][Index], Expansion
				end 
			end 
		else 
			if Raid == "Other" then 
				if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Raid] and AvyrRaidTools_DB.Notes[Expansion][Raid][Index] then 
					if ReturnDirectory then 
						return AvyrRaidTools_DB.Notes[Expansion][Raid]
					else 
						return AvyrRaidTools_DB.Notes[Expansion][Raid][Index], _ARTG.DataFuncs.GetRaidInfo("exp.data.name",Expansion) .. " > Other" 
					end 
				end 
			else 
				if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Raid] and AvyrRaidTools_DB.Notes[Expansion][Raid][Boss] and 
				AvyrRaidTools_DB.Notes[Expansion][Raid][Boss][Index] then 
					local ExpansionName = _ARTG.DataFuncs.GetRaidInfo("exp.data.name",Expansion)
					local RaidName = _ARTG.DataFuncs.GetRaidInfo("raid.data.name",Raid,Expansion)
					local BossName = _ARTG.DataFuncs.GetRaidInfo("boss.data.name",Boss,Raid,Expansion)
					if ReturnDirectory then 
						return AvyrRaidTools_DB.Notes[Expansion][Raid][Boss]
					else 
						return AvyrRaidTools_DB.Notes[Expansion][Raid][Boss][Index], ExpansionName .. " > " .. RaidName .. " > " .. BossName
					end 
				end                
			end 
		end 
	end 
end 

_ARTG.SV.NoteEntry = function(Type,Action,...)
	if Type == "Header" then 
		if Action == "Summary" then 
			local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = _ARTG.SV.NoteEntry("Header","Unpack",...)
			if EntryType == "T" and arg1 and arg2 then 
				return _ARTG.ConvertToTime(arg1)
			elseif EntryType == "A" and arg3 and (not arg5 or (arg1 and arg2)) then 
				local SpellName,_,SpellIcon = GetSpellInfo(arg3)
				if SpellName then 
					if arg5 then 
						return _ARTG.ConvertToTime(arg1).." - |T"..SpellIcon..":0:0:0:0|t " .. SpellName
					else 
						return "|T"..SpellIcon..":0:0:0:0|t " .. SpellName
					end 
				end 
			elseif EntryType == "RH" and arg3 and (not arg5 or (arg1 and arg2)) then
				if arg5 then 
					return _ARTG.ConvertToTime(arg1).." - Avg. hp <"..arg3.."%"
				else 
					return "Avg. hp <"..arg3.."%"
				end 
			end 
		elseif Action == "Unpack" then 
			--"T",Time,ErrorMargin
			--"A",Time,ErrorMargin,SpellID,ExactMatch,UseTime,IgnoreDoT
			--"RH",Time,ErrorMargin,AvgPercent,IgnoreTanks,UseTime
			if ... then 
				local NoteEntry = {strsplit(":",...)}
				if NoteEntry[1] == "T" then 
					local Time,ErrorMargin
					if NoteEntry[2] and tonumber(NoteEntry[2]) then 
						Time = tonumber(NoteEntry[2])
					end 
					if NoteEntry[3] and tonumber(NoteEntry[3]) then 
						ErrorMargin = tonumber(NoteEntry[3])
					end 
					return "T",Time,ErrorMargin
				elseif NoteEntry[1] == "A" then 
					local Time,ErrorMargin,SpellID,ExactMatch,UseTime,IgnoreDoT
					if NoteEntry[2] and tonumber(NoteEntry[2]) then 
						Time = tonumber(NoteEntry[2])
					end 
					if NoteEntry[3] and tonumber(NoteEntry[3]) then 
						SpellID = tonumber(NoteEntry[3])
					end 
					ExactMatch = (type(NoteEntry[5]) == "string" and NoteEntry[5] == "1")
					UseTime = (type(NoteEntry[6]) == "string" and NoteEntry[6] == "1")
					IgnoreDoT = (type(NoteEntry[7]) == "string" and NoteEntry[7] == "1")
					if NoteEntry[4] and tonumber(NoteEntry[4]) then 
						ErrorMargin = tonumber(NoteEntry[4])
					end 
					return "A",Time,ErrorMargin,SpellID,ExactMatch,UseTime,IgnoreDoT
				elseif NoteEntry[1] == "RH" then 
					local Time,ErrorMargin,AvgPercent,IgnoreTanks,UseTime
					if NoteEntry[2] and tonumber(NoteEntry[2]) then 
						Time = tonumber(NoteEntry[2])
					end 
					if NoteEntry[3] and tonumber(NoteEntry[3]) then 
						AvgPercent = tonumber(NoteEntry[3])
					end 
					IgnoreTanks = (type(NoteEntry[5]) == "string" and NoteEntry[5] == "1")
					UseTime = (type(NoteEntry[6]) == "string" and NoteEntry[6] == "1")
					if NoteEntry[4] and tonumber(NoteEntry[4]) then 
						ErrorMargin = tonumber(NoteEntry[4]) 
					end 
					--[[
					LimitAvg = (type(NoteEntry[7]) == "string" and NoteEntry[7] == "1")
					if NoteEntry[8] and tonumber(NoteEntry[8]) then 
						PlayersAvg = tonumber(NoteEntry[8])
					end ]]
					return "RH",Time,ErrorMargin,AvgPercent,IgnoreTanks,UseTime
				end 
			end
		elseif Action == "Pack" then 
			local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = ...
			if EntryType == "T" then 
				--type,time,errorMargin
				return "T:"..(arg1 or 0)..":"..(arg2 or 5) 
			elseif EntryType == "A" then 
				--type,time,spellID,errorMargin,exactMatch,useTime,ignoreDoT
				return "A:"..(arg1 or 0)..":"..(arg3 or "")..":"..(arg2 or 5)..":"..(arg4 and "1" or "0")..":"..(arg5 and "1" or "0")..":"..(arg6 and "1" or "0")
			elseif EntryType == "RH" then 
				--type,Time,AvgPercent,ErrorMargin,IgnoreTanks,UseTime
				return "RH:"..(arg1 or 0)..":"..(arg3 or 50)..":"..(arg2 or 5)..":"..(arg4 and "1" or "0")..":"..(arg5 and "1" or "0")
			end 
		end 
	elseif Type == "Note" then 
		if Action == "Summary" then 
			local Note = ...
			local ReturnNote = Note
			local CDs = {}
			if strmatch(Note,"\023%d+:%a*:%w*\023") then 
				for CDLink in Note:gmatch("\023%d+:%a*:%w*\023") do
					ReturnNote = ReturnNote:gsub(CDLink,"/cd",1)
					insert(CDs,CDLink)
				end 
			end 
			return ReturnNote, CDs
		elseif Action == "DisplaySummary" then 
			local Note = ...
			local ReturnNote = Note
			if strmatch(Note,"\023%d+:%a*:%w*\023") then 
				for CDLink in Note:gmatch("\023%d+:%a*:%w*\023") do
					ReturnNote = ReturnNote:gsub(CDLink,_ARTG.SV.NoteEntry("CD","Display",CDLink).." ",1)
				end 
			end 
			local Keyword
			if _ARTG.SV.GetVariable("ND_EnableKeywords") then 
				if AvyrRaidTools_DB.KeywordsCD then 
					for _,word in ipairs(AvyrRaidTools_DB.KeywordsCD) do  
						if (word.CM and Note:find(word.Term)) or (not word.CM and Note:lower():find(word.Term:lower())) then 
							if word.Sound then 
								Keyword = word.Sound
							else
								Keyword = true  
							end 
							break 
						end 
					end 
				end
				if not Keyword then 
					if AvyrRaidTools_DB.Keywords then 
						for _,word in ipairs(AvyrRaidTools_DB.Keywords) do  
							if (word.CM and Note:find(word.Term)) or (not word.CM and Note:lower():find(word.Term:lower())) then 
								if word.Sound then 
									Keyword = word.Sound
								else
									Keyword = true  
								end 
								break 
							end 
						end 
					end  
				end 
			end
			return ReturnNote, Keyword            
		elseif Action == "Pack" then 
			local Note,CDs = ...
			for i = 1,getn(CDs) do 
				Note = Note:gsub("/cd",CDs[i],1)
			end 
			Note = Note:gsub("/cd","") --cleaning
			return Note
		end 
	elseif Type == "CD" then 
		if Action == "Display" then 
			local CDString = gsub(...,"\023","")
			local CD,Name,Mod = strsplit(":",CDString)
			if tonumber(CD) then 
				local CDID = tonumber(CD)
				if GetSpellInfo(CDID) then 
					local _,_,Icon = GetSpellInfo(CDID)  
					Icon = Icon or 134400
					if Name == "" then 
						return "|T"..Icon..":0:0:0:0|t",CDID,Name         
					else 
						return "|T"..Icon..":0:0:0:0|t"..Name,CDID,Name                
					end  
				end 
				return "Unknown CD ",CDID,Name
			end 
			return "Unknown CD ",CD,Name
		elseif Action == "Create" then 
			local CD,Name,Mod = ...
			CD = CD or ""
			Name = Name or ""
			Mod = Mod or ""
			return "\023"..CD..":"..Name..":"..Mod.."\023"
		end 
	end 
end 

_ARTG.SV.NoteSort = function(Note)
	for i,v in ipairs(Note) do 
		local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = _ARTG.SV.NoteEntry("Header","Unpack",v[1])
		if EntryType == "T" or arg5 then 
			v.Time = arg1
		end 
	end 
	
	for i = 1,getn(Note) do 
		if Note[i].Time then 
			local bi = i - 1
			local RefIndex = i
			while bi > 0 do 
				if Note[bi].Time and Note[RefIndex].Time < Note[bi].Time then 
					local header,data,time = Note[RefIndex][1],Note[RefIndex][2],Note[RefIndex].Time
					remove(Note,RefIndex)
					insert(Note,bi,{header,data,Time = time})
					RefIndex = bi
				end 
				bi = bi - 1
			end 
			if RefIndex == i then 
				bi = i + 1
				while bi <= getn(Note) do 
					if Note[bi].Time and Note[RefIndex].Time > Note[bi].Time then 
						local header,data,time = Note[RefIndex][1],Note[RefIndex][2],Note[RefIndex].Time
						insert(Note,bi,{header,data,Time = time})
						remove(Note,RefIndex)
						RefIndex = bi
					end 
					bi = bi + 1
				end 
			end 
		end 
	end 
	
	--clean table
	for i,v in ipairs(Note) do 
		v.Time = nil
	end 
end 

local MaxFavorites = 40
_ARTG.SV.CooldownEdit = function(Action,...)
	if Action == "Create" then 
		local CDLink = ...
		insert(AvyrRaidTools_DB.EditorCooldowns.LastCreated,1,CDLink)
		if getn(AvyrRaidTools_DB.EditorCooldowns.LastCreated) > 3 then 
			remove(AvyrRaidTools_DB.EditorCooldowns.LastCreated,4)
		end
		_ARTG.Editor:UpdateFavoriteCDs()
	elseif Action == "EditFavorite" then 

	elseif Action == "RemoveFavorite" then 
		local CDLink = ...
		local CDIndex =  _ARTG.SV.CooldownEdit("IsFavorite",CDLink)
		if CDIndex then 
			remove(AvyrRaidTools_DB.EditorCooldowns.Favorites,CDIndex)
			_ARTG.Editor.UpdateAllEntryNote()
			_ARTG.Editor:UpdateFavoriteCDs()
		end 
	elseif Action == "AddFavorite" then 
		local CDLink = ...
		if not _ARTG.SV.CooldownEdit("IsFavorite",CDLink) and getn(AvyrRaidTools_DB.EditorCooldowns.Favorites) <= MaxFavorites then 
			insert(AvyrRaidTools_DB.EditorCooldowns.Favorites,1,CDLink)
			_ARTG.Editor.UpdateAllEntryNote()
			_ARTG.Editor:UpdateFavoriteCDs()
		end 
	elseif Action == "MaxFavorite" then 
		return MaxFavorites
	elseif Action == "IsFavorite" then 
		local CDLink = ...
		for i,v in ipairs(AvyrRaidTools_DB.EditorCooldowns.Favorites) do 
			if v == CDLink then 
				return i
			end 
		end 
	end 
end



