local Widgets = _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin
local insert, ipairs = table.insert, ipairs;

_Avyr_Global_ADDON_Elements_Lib.FontStringParent = _Avyr_Global_ADDON_Elements_Lib.FontStringParent or CreateFrame("Frame")
local function Release(self)
    self.ColorThemeAlignment = nil
    self:SetTextColor(1,0.82,0)
    self:SetParent(_Avyr_Global_ADDON_Elements_Lib.FontStringParent)
    local Font, _, Flags = self:GetFont()
    self:SetFont(Font, 11, nil)
    self:SetHeight(0)
    self:SetWidth(0)
    self:SetJustifyH("CENTER")
    self:SetJustifyV("CENTER")
    self:Hide()
end

local function SetFontSizeOnly(self,Size)
    local Font, _, Flags = self:GetFont()
    self:SetFont(Font, Size, Flags)
end 

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:FetchFontString(Parent)
    local String
    for i, v in ipairs(_Avyr_Global_ADDON_Elements_Lib.FontStrings) do
        if not v:IsShown() then
            String = v
        end
    end

    if not String then
        String = _Avyr_Global_ADDON_Elements_Lib.FontStringParent:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        local Font, _, Flags = String:GetFont()
        String:SetFont(Font, 11, Flags)
        insert(_Avyr_Global_ADDON_Elements_Lib.FontStrings,String)
        String.Release = Release
        String.SetFontSizeOnly = SetFontSizeOnly
    end

    String:ClearAllPoints()
    String:SetParent(Parent or _Avyr_Global_ADDON_Elements_Lib.FontStringParent)
    String:SetText("")
    String:Show()

    return String
end